; EX3_asm


	bra.s	start
	dc.l	0
	dc.w	$4afb
fname	dc.w	fname_e-fname-2
	dc.b	"EX3 v1.04"
fname_e	ds.b	0
	ds.w	0

	in	win1_ass_pe_keys_pe
	in	win1_ass_pe_qdos_pt
	in	win1_ass_pe_keys_wwork
	in	win1_ass_pe_keys_wstatus
	in	win1_ass_pe_keys_wman
	in	win1_ass_pe_keys_wdef

id	equ	0
wmvec	equ	4
xwee	equ	8
ywee	equ	$0A
xbig	equ	$0C
ybig	equ	$0E
blk_def	equ	$10
wron	equ	$18
color	equ	$19

*
start	lea	(a6,a4.l),a6	dataspace
	bsr.s	ope		open a con channel . .
	move.l	a0,id(a6) 	. . keep the ID
	moveq	#iop_pinf,d0
	moveq	#-1,d3
	trap	#3
	tst.l	d0		ptr_gen present? . .
	bne	sui	---->	. . no
	move.l	a1,wmvec(a6)	keep WM vector . .
	beq	sui	---->	. . wasn't there!
	lea	wd0,a3		address of window definition
	movea.l	a1,a2		set WM vector in A2
	move.l	#ww0_0,d1 	size of working definition . .
	bsr	getsp		. . sets ALCHP'd address to A0 . .
	movea.l	a0,a4		. . and to A4
	lea	wst0,a1		Clear the status . .
	movea.l	a1,a0		. . area . .
	moveq	#wst0_e-wst0-1,d1	. . and 4 loose items
st1	clr.b	(a0)+
	dbf	d1,st1
	move.b	#4,color(a6)	set colour green
	move.l	#$20001,blk_def(a6) set block size 2x1
	movea.l	id(a6),a0 	Replace the channel ID
	move.l	wd_xmin+wd_rbase(a3),d1     minimum size
	andi.l	#$FFF0FFF,d1	Lop off the scaling factors
	jsr	wm_setup(a2)	Set up the working definition
	moveq	#-1,d1		Set the window . .
	jsr	wm_prpos(a2)	. . where the pointer is
	jsr	wm_wdraw(a2)	Draw the contents
	bsr	setlim
wrpt	jsr	wm_rptr(a2)	Read the pointer

	beq.s	no_err
	bra	sui


*

con	dc.w	3
	dc.b	'con'

ope	lea	con,a0		To open "con" . .
	moveq	#-1,d1		. . for this job
	moveq	#0,d3
	moveq	#io_open,d0
	trap	#2
	rts

; We come here if we exit from wm_rptr without an error
; This means that D4 is non-zero which in turn means either that there
; was a window event (eg CTRL/F4) or that a loose item action routine
; has set a non-zero value in D4. If there was a window event (and no loose
; item) the appropriate bit will have been set in the event vector in the
; status area.

; If a loose item has a select key equal to that for an event, the event
; will not be detected by WM_RPTR since the loose item's action routine
; will have been called instead. The loose item's action routine can then
; set the event bit in the event vector and force an exit from WM_RPTR by
; setting the event number in D4. In that case the following code would be
; used. On the other hand the loose item's action routine could process the
; event internally without exiting from WM_RPTR.

no_err	movea.l	(a4),a1		status area
	btst	#pt__can,wsp_weve(a1)
	bne	sui		Exit
	btst	#pt__move,wsp_weve(a1)
	beq.s	no_er1
	bsr	move
	bra.s	noe
no_er1	btst	#pt__wsiz,wsp_weve(a1)
	beq	noe
	bsr.s	resze
noe	bsr	setlim
	bsr	stwin
	bra.s	wrpt		read pointer again


; Loose item action routines

; MOVE

afun0_0	bsr	move
af1	move.w	wwl_item(a3),d1	item number
	move.b	#wsi_mkav,ws_litem(a1,d1.w)	  ask for redraw
	moveq	#-1,d3		selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	     available
	bsr	setlim
	bsr	stwin
	moveq	#0,d4
	moveq	#0,d0
	rts

; RESIZE

afun0_1	move.l	a3,-(a7)
	movea.l	ww_wdef(a4),a3	window definition
	bsr.s	resze
	movea.l	(a7)+,a3		restore pointer to loose item
	bra.s	af1

******************************************************************
*						     *
*  To perform the resize we need to			     *
*    a. Find the amount of resize (by wm_chwin)		     *
*    b. Throw away the current working definition (by wm_unset)  *
*    c. Find the new size (by wm_fsize) 		     *
*    d. Get space for the new working definition (by getsp)      *
*    e. Set up the new working definition  (by wm_setup)	     *
*    f. Position the new window  (by wm_prpos)		     *
*    g. Draw the contents  (by wm_wdraw)		     *
*						     *
* Comments					     *
*   On a. 					     *
*    We have to set the resize bit in the window byte of the     *
*    event vector in the status area before wm_chwin is called.  *
*    The change in size is returned in D1 and the window size    *
*    event number is returned in D4.			     *
*						     *
*   On c. 					     *
*    On entry to wm_fsize, D1 must contain the requested size.   *
*    This size must be chosen carefully. It must be no bigger    *
*    than the maximum in the window definition. It must be	     *
*    smaller than the maximum size for the window layout. The    *
*    x-size must be a multiple of 4 (to allow proper stippling.  *
*    Finally the size must not be bigger than the current screen *
*    size with allowance for shadow and border.		     *
*    On exit D1 contains the actual size and D2.W contains the   *
*    number of the repeated section.			     *
*    In this example we do not really need to use wm_fsize since *
*    we know that D2.W will be zero and that the value in D1     *
*    will be that on entry (since we have a variable window).    *
*						     *
*   On d. 					     *
*    The space needed is found from the label ww0_0 set in the   *
*    window definition.				     *
*						     *
*   On e. 					     *
*    For wm_setup we need on entry:			     *
*     D1 = size					     *
*     A0 = channel ID				     *
*     A1 -> status area				     *
*     A3 -> window definition 			     *
*     A4 -> space for working definition		     *
*						     *
*   On f. 					     *
*    On entry to wm_prpos we need the position in D1.	     *
*    In order to ensure that the bottom right corner of the      *
*    resized window is in the same position as that of the old   *
*    we need to subtract the increase in size from the pointer   *
*    origin in the old window.			     *
*    The new position is thus wd_org plus ww_xsize minus the     *
*    new size.					     *
*						     *
******************************************************************



resze	move.l	ww_xorg(a4),d7
	move.l	ww_wdef(a4),a5	window def
	add.l	wd_xorg(a5),d7
	add.l	ww_xsize(a4),d7	ptr position for PRPOS (optr)
	bset	#pt__wsiz,wsp_weve(a1)
	jsr	wm_chwin(a2)	sets change to D1 (mv)
	bclr	#pt__wsiz,wsp_weve(a1)
	move.w	wd_rbase+wd_xmin(a5),d5
	andi.w	#$fff,d5
	move.w	ww_xsize(a4),d4
	swap	d1
	sub.w	d1,d4
	cmp.w	d5,d4
	bgt.s	resze1		d4 is greater
	move.w	d5,d4
resze1	move.w	wd_xsize(a5),d5
	cmp.w	d5,d4
	blt.s	resze2		d4 is smaller
	move.w	d5,d4
resze2	moveq	#3,d3
	add.w	d4,d3
	andi.w	#$fffc,d3 	keep answer in D3.W  (mv)
	move.w	wd_rbase+wd_ymin(a5),d5
	andi.w	#$fff,d5
	move.w	ww_ysize(a4),d4
	swap	d1
	sub.w	d1,d4
	cmp.w	d5,d4
	bgt.s	resze3		d4 is greater
	move.w	d5,d4
resze3	move.w	wd_ysize(a5),d5
	cmp.w	d5,d4
	blt.s	resze4		d4 is smaller
	move.w	d5,d4
resze4	swap	d3
	move.w	d4,d3		D3 = new mv x | y
	jsr	wm_unset(a2)
	bsr	rechp
	move.l	d3,d1		new size
	jsr	wm_fsize(a2)
	move.l	d1,-(a7)		keep size pro tem
	move.l	#ww0_0,d1 	space needed
	bsr	getsp
	move.l	(a7)+,d1		replace size
	movea.l	a0,a4		new wwd
	movea.l	id(a6),a0 	replace ID
	jsr	wm_setup(a2)
;
; The position for PRPOS is optr-mv with minimum of 4 | 2
;
	bsr	setlim
	move.l	d7,d1
	swap	d1
	swap	d3
	sub.w	d3,d1
	cmpi.w	#4,d1
	bge.s	resze5		D1 not less than 4
	move.w	#4,d1		set minimum of 4
resze5	swap	d1
	swap	d3
	sub.w	d3,d1
	cmpi.w	#2,d1
	bge.s	resze6		D1 not less than 2
	move.w	#2,d1		set minimum of 2
resze6	jsr	wm_prpos(a2)
	jsr	wm_wdraw(a2)
	bra	stwin





; EXIT

afun0_2	moveq	#0,d0
	moveq	#pt__can,d4	ESC
	bset	#pt__can,wsp_weve(a1)
	rts


; Clear

afun0_3
	move.w	wwl_item(a3),d1		item number
	move.b	#wsi_mkav,ws_litem(a1,d1.w)	ask for redraw
	moveq	#-1,d3			selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)		available
	bsr	stwin
	bra	clst


; ON/OFF

afun0_4	tst.w	ws_citem(a1)	is there a current item? . .
	bmi	af04_2		. . no
	jsr	wm_drbdr(a2)	clear its border
af04_2
	bsr	on_off
	bsr	stwin
	bsr	dloop		drawing
	bsr	on_off
	moveq	#0,d4
	moveq	#0,d0
af04_1	rts



setlim	move.l	a5,-(a7)
	move.l	ww_xorg(a4),d0	window origin
	movea.l	ww_pinfo(a4),a5	-> info list
	add.l	wwi_elen+wwi_xorg(a5),d0	x/ywee
	move.l	d0,xwee(a6)
	add.l	wwi_elen+wwi_xsiz(a5),d0	x/ybig
	move.l	d0,xbig(a6)
	movea.l	(a7)+,a5
	rts

; on_off toggles ON and OFF
; At entry A0 = channel ID
;	 A1 -> status area
;	 A4 -> working definition

on_off	movea.l	a1,a5		keep A1 pro tem
	tst.b	wron(a6)
	beq	on_off1
	lea	txt3,a1
	bra	on_off2
on_off1	lea	txt2,a1
on_off2	moveq	#4,d1		switch loose item ON / OFF
	jsr	wm_stlob(a2)
	eori.b	#1,wron(a6)	switch marker
	moveq	#4,d3
	move.b	wron(a6),d0
	lsl.b	#4,d0		0 or 16
	movea.l	a5,a1		replace A1
on_off3	move.b	d0,ws_litem(a1,d3.w)	set all to (un)available
	dbf	d3,on_off3
	moveq	#0,d3		draw all loose items
	jsr	wm_ldraw(a2)
	rts

dloop
	move.b	color(a6),d6	set initial colour
	moveq	#0,d1		zero 1st ptr position
	moveq	#-1,d3
dloop_2	moveq	#3,d2		wait for key/button press
dloop_1	addq.l	#8,a1		-> pointer record
	moveq	#iop_rptr,d0
	trap	#3
	subq.l	#8,a1		back to status area
	move.b	wsp_kstr(a1),d0	keystroke
	cmpi.b	#1,d0
	beq	dlp1
	cmpi.b	#2,d0
	beq	af04_1		exit
	moveq	#0,d5		for colour change
	bclr	#5,d0		-> upper case
	cmpi.b	#"O",d0
	beq	af04_1		exit
	cmpi.b	#"C",d0
	bne	dloop_3
	bsr	stwin
	bsr	cls
	bra	dloop_2
dloop_3	cmpi.b	#"B",d0
	beq	c_black
	cmpi.b	#"G",d0
	beq	c_green
	cmpi.b	#"R",d0
	beq	c_red
	cmpi.b	#"W",d0
	bne	dloop_1
c_white	addq.b	#3,d5
c_green	addq.b	#2,d5
c_red	addq.b	#2,d5
c_black	move.b	d5,d6		set colour
	move.b	d6,color(a6)
	bra	dloop_1

; dlp1 does drawing and returns to dloop_1
;


dlp1	move.l	d1,d7		set old_p = new_p
	bsr	blk1		draw a point
	moveq	#12,d2		key up or pointer moved
dlp1_1	moveq	#iop_rptr,d0
	addq.l	#8,a1
	trap	#3
	subq.l	#8,a1
	cmp.l	d1,d7		is new_p (D1.L) the old_p (D7.L)? . .
	beq	dloop_2		. . yes so exit
	bsr	blk1		do drawing old_p to new_p
	move.l	d1,d7		set new_p to old_p
	bra	dlp1_1

; blk1 draws blocks from D7 to D1

blk1	movem.l	d1-4/d7/a1,-(a7)
	cmp.l	d1,d7
	bne	blk1_1		draw a line
	move.l	d1,blk_def+4(a6)
	bsr	blk		draw a "point"
	bra	blk1_e		exit
blk1_1	moveq	#0,d2
	move.l	d7,d3		old p
	move.l	d1,d4		new p
	swap	d3
	swap	d4
	sub.w	d3,d4		xn - xo
	move.w	d4,d5		keep xn - xo in D5
	bpl	blk1_2		xn >= xo
	move.w	d4,d2		keep xn - xo if negative
	neg.w	d4		ABS(xn - xo)
blk1_2	swap	d2
	swap	d5
	move.w	d1,d3		yn
	sub.w	d7,d3		yn - yo
	move.w	d3,d5		keep yn - yo in D5
	bpl	blk1_3		yn > yo
	move.w	d3,d2		keep yn - yo if negative
	neg.w	d3		ABS(yn - yo)
blk1_3	cmp.w	d3,d4
	blt	blk1_4		d4 < d3

; draw on x count

	swap	d2
	move.l	d7,d3
	swap	d3
	add.w	d2,d3		xo + [xn - xo] if negative
	move.w	d4,d0		count
	bra	blk1_5
blk1_6	move.w	d0,blk_def+4(a6)
	add.w	d3,blk_def+4(a6)	x-origin
	move.w	d0,d1
	add.w	d2,d1
	muls	d5,d1
	swap	d5
	divs	d5,d1
	swap	d5
	add.w	d7,d1
	move.w	d1,blk_def+6(a6)	y-origin
	bsr	blk
blk1_5	dbf	d0,blk1_6
blk1_e	movem.l	(a7)+,d1-4/d7/a1
	rts

; draw on y count

blk1_4	move.w	d7,d4
	add.w	d2,d4		yo + [yn - yo] if negative
	move.w	d3,d0		count
	swap	d7
	bra	blk1_7
blk1_8	move.w	d0,blk_def+6(a6)
	add.w	d4,blk_def+6(a6)	y-origin
	swap	d5
	move.w	d0,d1
	add.w	d2,d1
	muls	d5,d1
	swap	d5
	divs	d5,d1
	add.w	d7,d1		x-origin
	move.w	d1,blk_def+4(a6)
	bsr	blk
blk1_7	dbf	d0,blk1_8
	bra	blk1_e


; blk prints a 2x1 block

blk	movem.l	d0/d3,-(a7)
	move.w	xbig(a6),d0
	subq.w	#1,d0
	cmp.w	blk_def+4(a6),d0
	ble	blk_e
	move.w	xwee(a6),d0
	sub.w	d0,blk_def+4(a6)
	bmi	blk_e
	move.w	ybig(a6),d0
	cmp.w	blk_def+6(a6),d0
	ble	blk_e
	move.w	ywee(a6),d0
	sub.w	d0,blk_def+6(a6)
	bmi	blk_e
	move.b	color(a6),d1
	lea	blk_def(a6),a1
	moveq	#-1,d3
	moveq	#sd_fill,d0
	trap	#3
blk_e	movem.l	(a7)+,d0/d3
	rts

; stwin sets the window to 2nd inf window

stwin	move.l	a1,-(a7)
	moveq	#1,d1		2nd inf window
	moveq	#-1,d2
	jsr	wm_swinf(a2)
	moveq	#0,d1
	bsr	overt
	moveq	#0,d1		black
	bsr	paper
	movea.l	(a7)+,a1
	rts


papert	moveq	#-1,d3
paper	moveq	#sd_setpa,d0
	bsr	tr3
	moveq	#sd_setst,d0
tr3	trap	#3
	tst.l	d0
tr4	bne	sui	---->
	rts

inkt	moveq	#-1,d3
ink	moveq	#sd_setin,d0
	bra	tr3

att	moveq	#-1,d3
at	moveq	#sd_pos,d0
	bra	tr3

overt	moveq	#-1,d3
over	moveq	#sd_setmd,d0
	bra	tr3

clst	moveq	#-1,d3
cls	moveq	#sd_clear,d0
	bra	tr3

utm	movea.w	ut_mtext,a2
	jsr	(a2)
	bra	tr4



	in win1_ass_pe_ex3w_asm



	in	win1_ass_pe_peas_sym_lst
	lib	win1_ass_pe_peas_bin

	in	win1_ass_pe_csprc_sym_lst
	lib	win1_ass_pe_csprc_bin
